const initialState = {
    date: null,
    loadingDate: false
}

const state = {
    date: initialState.date,
    loadingDate: !initialState.loadingDate
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    date(state) {
        return state.date
    },
    /**
     * 
     * @param {*} state 
     */
    loadingDate(state) {
        return state.loadingDate
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setDate(state, payload) {
        state.date = payload
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setLoadingDate(state, loading) {
        state.loadingDate = !!loading
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    initDate({ commit }, payload) {
        commit('setDate', payload)
        commit('setLoadingDate')
    },
    /**
     * 
     * @param {*} param0 
     */
    resetDate({ commit }) {
        commit('setLoadingDate', true)
        commit('setDate', null)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}